#include <string.h>
#include "plugin.h"

enum {
  MTitle,
  MIndentLeft,
  MIndentRight
};

static struct PluginStartupInfo Info;
unsigned char Space;
unsigned char Tab;

char *GetMsg(int MsgId)
{
  return(Info.GetMsg(Info.ModuleNumber,MsgId));
}

int IsWhite(char c) {
  if ((c == Space) || (c == Tab))
    return TRUE;
  else
    return FALSE;
}

void WINAPI _export SetStartupInfo(const struct PluginStartupInfo *psi)
{
  Info=*psi;
}

void WINAPI _export GetPluginInfo(struct PluginInfo *pi)
{
  static char *PluginMenuStrings[1];

  pi->StructSize=sizeof(struct PluginInfo);
  pi->Flags=PF_EDITOR|PF_DISABLEPANELS;
  PluginMenuStrings[0]=GetMsg(MTitle);
  pi->PluginMenuStrings=PluginMenuStrings;
  pi->PluginMenuStringsNumber=sizeof(PluginMenuStrings)/sizeof(PluginMenuStrings[0]);
}

HANDLE WINAPI _export OpenPlugin(int OpenFrom,int item)
{
  struct FarMenuItem MenuItems[2] = {0};
  int menu;
  struct EditorInfo ei;
  struct EditorGetString egs;
  struct EditorSetString ess;
  struct EditorConvertPos ecp;
  struct EditorSetPosition esp;
  struct EditorSelect es;
  int i,j,x;
  int loop;
  struct CharTableSet cts;
  char TabStr[2];

  MenuItems[0].Selected = 1;
  strcpy(MenuItems[0].Text,GetMsg(MIndentLeft));
  strcpy(MenuItems[1].Text,GetMsg(MIndentRight));

  if ((menu = Info.Menu(Info.ModuleNumber,-1,-1,0,FMENU_WRAPMODE,GetMsg(MTitle),NULL,NULL,
      NULL,NULL,MenuItems,sizeof(MenuItems)/sizeof(MenuItems[0]))) == -1)
    return INVALID_HANDLE_VALUE;

  Info.EditorControl(ECTL_GETINFO,&ei);
  // To prevent a wrong value to be taken from previous plugin instance
  Space = 32;
  Tab = 9;
  if (ei.TableNum != -1)
    if (Info.CharTable(ei.TableNum,&cts,sizeof(struct CharTableSet)) != -1) {
        Space = cts.EncodeTable[Space];
        Tab = cts.EncodeTable[Tab];
    }
  TabStr[0] = Tab;
  TabStr[1] = '\0';

  if (ei.BlockType != BTYPE_NONE) {
    i = ei.BlockStartLine;
    loop = TRUE;
  }
  else {
    i = ei.CurLine;
    loop = FALSE;
  }

  egs.StringNumber = i;
  Info.EditorControl(ECTL_GETSTRING,&egs);

  do {
    j = 0;
    x = 0;
    while (IsWhite(egs.StringText[j]) && (j < egs.StringLength))
      j++;
    if (((j > 0) || (menu == 1)) && (j < egs.StringLength)) {
      ecp.StringNumber = i;
      ecp.SrcPos = j+1;
      Info.EditorControl(ECTL_REALTOTAB,&ecp);
      x = (ecp.DestPos-1)/ei.TabSize;
      if (((ecp.DestPos-1)%ei.TabSize == 0) && (menu == 0))
        x--;
      if (menu == 1)
        x++;
      ess.StringNumber = i;
      ess.StringText = &egs.StringText[j];
      ess.StringEOL = egs.StringEOL;
      ess.StringLength = egs.StringLength - j;
      Info.EditorControl(ECTL_SETSTRING,&ess);
      if (x > 0) {
        esp.CurLine = i;
        esp.CurPos = 0;
        esp.Overtype = 0;
        esp.CurTabPos = esp.TopScreenLine = esp.LeftPos = -1;
        Info.EditorControl(ECTL_SETPOSITION,&esp);
        for(j=0;j<x;j++)
          Info.EditorControl(ECTL_INSERTTEXT,TabStr);
      }
    }
    i++;
    if (i < ei.TotalLines) {
      egs.StringNumber = i;
      Info.EditorControl(ECTL_GETSTRING,&egs);
      if ((egs.SelStart == -1) || (egs.SelStart == egs.SelEnd))
        loop = FALSE;
    }
    else
      loop = FALSE;
  } while (loop);

  esp.CurLine = ei.CurLine;
  esp.CurPos = ei.CurPos;
  esp.TopScreenLine = ei.TopScreenLine;
  esp.LeftPos = ei.LeftPos;
  esp.Overtype = ei.Overtype;
  esp.CurTabPos = -1;
  Info.EditorControl(ECTL_SETPOSITION,&esp);

  return INVALID_HANDLE_VALUE;
}
